--
-- FunScript.lua
--
-- @author Alex2009
-- @date  01/12/2011
--

FunScript = {};
g_BaseDir = g_currentModDirectory;

function FunScript:loadMap(name)
    if string.find(name,"map01.i3d",1) then
        --Triggerevent hinzufgen...
        self.TriggerEvent = FunScript.TriggerEvent; 
        
        --Variabeln setzen...
        self.FunScriptActive = false;
        self.FunScriptDisabled = false;
        self.FunScriptCount = 150;
        self.FunScriptLights = 0;
        self.SetLightsOnOrOff = true;
        self.FunScriptLightNumber = 1;
        
        
        
        --I3D ffnen
        self.I3D = g_currentMission:loadMap(Utils.getFilename("Weihnachtsbaum.i3d", g_BaseDir));
 
        --Baum Object suchen...
        self.FunScriptObject = getChildAt(getChildAt(self.I3D,0), 0);
        
        --Trigger suchen...
        local FunScriptTrigger = getChildAt(getChildAt(self.I3D,0),2);
        addTrigger(FunScriptTrigger, "TriggerEvent", self);
        
        --Lichter laden...
        self.FunScriptLightTab = {};
	    local count = 1;
        local maxcount = getNumOfChildren(getChildAt(getChildAt(self.I3D,0),0)) - 1;
	    while true do
            if count <= maxcount then
                local LightIndex = getChildAt(getChildAt(getChildAt(self.I3D,0),0),count);
                if LightIndex == 0 or LightIndex == nil then
                    print("(FunScript) Loaded " .. count-1 .. " lights.");
                    self.FunScriptLights = count-1;
                    break;
                end;
                setVisibility(LightIndex,false);
                self.FunScriptLightTab[count] = {index=LightIndex}
                count = count + 1;
            else
                print("(FunScript) Loaded " .. count-1 .. " lights.");
                self.FunScriptLights = count-1;
                break;
            end;
	    end;
        self.FunScriptLoaded = true;
	end;
end;

function FunScript:deleteMap()
    if self.motorSound ~= nil then
        delete(self.motorSound);
    end;
end;

function FunScript:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FunScript:keyEvent(unicode, sym, modifier, isDown)
end;

function FunScript:update(dt)
    if self.FunScriptActive then
        rotate(self.FunScriptObject, 0, -0.0006*dt, 0);
        if self.FunScriptCount ~= 0 then
            self.FunScriptCount = self.FunScriptCount - 1;
        else
            --Lichter ndern...
            local count = 1;
            while true do
                if (count > self.FunScriptLightNumber) or (count > self.FunScriptLights) then
                    if self.FunScriptLightNumber >= self.FunScriptLights then
                        self.FunScriptLightNumber = 1;
                        self.FunScriptCount = 100;
                        self.SetLightsOnOrOff = not self.SetLightsOnOrOff;
                    else
                        self.FunScriptLightNumber = self.FunScriptLightNumber + 1;
                        self.FunScriptCount = 100;
                    end;
                    break;
                else
                    setVisibility(self.FunScriptLightTab[count].index,self.SetLightsOnOrOff);
                    count = count + 1;    
                end;
            end;
        end;
    else
        if not self.FunScriptDisabled then
            --Lichter abschalten...
            self.SetLightsOnOrOff = false;
            self.FunScriptLightNumber = 1;
        	local count = 1;
            while true do
                if count > self.FunScriptLights then
                    break;
                else
                    setVisibility(self.FunScriptLightTab[count].index,self.SetLightsOnOrOff);               
                end;
                count = count + 1; 
            end;
            self.FunScriptDisabled = true;
        end;
    end;
end;

function FunScript:draw(dt)
end;

function FunScript:TriggerEvent(triggerId, otherId, onEnter, onLeave, onStay)
    if g_currentMission.player ~= nil and g_currentMission.player.rootNode == otherId and self.FunScriptLoaded then
        if onEnter then
            self.FunScriptActive = true;
            self.FunScriptDisabled = false;
            self.SetLightsOnOrOff = true;
            setSamplePitch(self.FunScriptSound, 1);
            playSample(self.FunScriptSound, 0, 0.6, 0);
        elseif onLeave then
            self.FunScriptActive = false;
            self.FunScriptDisabled = false;
            stopSample(self.FunScriptSound);
        end;
    end;
end;
addModEventListener(FunScript);